void PrecomputeVertexNormals(D3Object_ptr Object)
{	// This function is used by the LoadAscFile function. It precomputes all vertexnormals
	Normal a,b;
	int    deler;
	float  x,y,z,length;	
	
	// Take a vertex
	for (int count=0;count<Object->NumVertices; count++)
	{	deler = 0; // deler is used as to divide x, y and z by the number of faces which share the vertex
		// Go though all faces to see which faces have this vertex in common
		for (int count2=0;count2<Object->NumFaces; count2++)
		{	// Now if if the face shares the vertex -- compute face normal and add its x component to x, its y to y and its z to z
			// also increase deler.
			if(	Object->Faces[count2].a==count || Object->Faces[count2].b==count || Object->Faces[count2].c==count   )
			{	deler++;
				a.x = Object->Vertices_local[Object->Faces[count2].c].x - Object->Vertices_local[Object->Faces[count2].a].x;
				a.y = Object->Vertices_local[Object->Faces[count2].c].y - Object->Vertices_local[Object->Faces[count2].a].y;
				a.z = Object->Vertices_local[Object->Faces[count2].c].z - Object->Vertices_local[Object->Faces[count2].a].z;
				b.x = Object->Vertices_local[Object->Faces[count2].b].x - Object->Vertices_local[Object->Faces[count2].a].x;
				b.y = Object->Vertices_local[Object->Faces[count2].b].y - Object->Vertices_local[Object->Faces[count2].a].y;
				b.z = Object->Vertices_local[Object->Faces[count2].b].z - Object->Vertices_local[Object->Faces[count2].a].z;	
				
				x = x + ((b.y*a.z)-(b.z*a.y));	
				y = y + ((b.z*a.x)-(b.x*a.z));
				z = z + ((b.x*a.y)-(b.y*a.x));
			}	
		}
		if (deler != 0)
		{	Object->Vertices_normalStat[count].x = x / deler; 
			Object->Vertices_normalStat[count].y = y / deler; 
			Object->Vertices_normalStat[count].z = z / deler; 
		} 
		// Normalize the length to 1 to save dividing time in our (realtime) routine as dividing by 1 is not needed !
		length = sqrt((Object->Vertices_normalStat[count].x*Object->Vertices_normalStat[count].x) + 
					  (Object->Vertices_normalStat[count].y*Object->Vertices_normalStat[count].y) + 
					  (Object->Vertices_normalStat[count].z*Object->Vertices_normalStat[count].z) );
		
		Object->Vertices_normalStat[count].x=Object->Vertices_normalStat[count].x / length;
		Object->Vertices_normalStat[count].y=Object->Vertices_normalStat[count].y / length;
		Object->Vertices_normalStat[count].z=Object->Vertices_normalStat[count].z / length;
		
		x=0;y=0;z=0;
	}
}


void LightenObject(D3Object_ptr Object)
{	// function calculates the amount of light at every vertex
	// Just calculat the angle between every vertexnormal, which we have precalculated, and the ligthsource.
	// This is all standard  highschool math.
	float x,y,z;
	float angle;
	for (int count=0;count<Object->NumVertices;count++)
	{	x = Object->Vertices_normalStat[count].x;
		y = Object->Vertices_normalStat[count].y;
		z = Object->Vertices_normalStat[count].z;
		
		// 866  is the distance to the lightsource ( SQRT((500^2)+(500^2)+(500^2)) )
		// officially we would also divide "angle" by the length of the Vertexnormal but we normalised it to 1 so there is no need for that
		// You don't want to calculate a sqrt for every Vertex !
		// Ofcource we should eliminate the cos but I don't have any good idea's for doing this
		// Suggestions ?
		angle = 1-fabs(cos(( (x * Object->Spotlight.x) + (y * Object->Spotlight.y) + (z * Object->Spotlight.z) )/866));
		
		// Now scale every colorcomponent by "angle" as this is a value in the range: (1-abs(-1..1)) -> (0..1)
		Object->Vertices_screen[count].r = Object->Vertices_local[count].r * angle;
		Object->Vertices_screen[count].b = Object->Vertices_local[count].b * angle;
		Object->Vertices_screen[count].g = Object->Vertices_local[count].g * angle;
	}
}

